cordova.define("ntaapp-plugin-mjpki.MJPKIPlugin", function(require, exports, module) {
var MJPKIPlugin = {
    SignMultiple: function (dataArray) {
        return addMjpkiQueue(() => new Promise((resolve, reject) => {
            console.log('MJPKIPlugin.SignMultiple');
            cordova.exec((ret) => {
                let signatureStringArray;
                let certificateString;
                let digitalCertificateTypeString;

                console.log(ret);

                signatureStringArray = ret.slice(0, -2);
                certificateString = ret.slice(-2, -1)[0];
                digitalCertificateTypeString = ret.slice(-1)[0];

                console.log(signatureStringArray);
                console.log(certificateString);
                console.log(digitalCertificateTypeString);

                resolve([signatureStringArray, certificateString, digitalCertificateTypeString]);
            }, (err) => {
                reject(getMjpkiErrorCode(err));
            }, 'MJPKIPlugin', 'SignMultiple', dataArray);
        }));
    }
};

let MjpkiPromiseQueue = Promise.resolve();
function addMjpkiQueue(func) {
    MjpkiPromiseQueue = MjpkiPromiseQueue.then(func);
    let promise = MjpkiPromiseQueue;
    MjpkiPromiseQueue = MjpkiPromiseQueue.catch(reason => console.log(reason));
    return promise;
}

function getMjpkiErrorCode(code) {
    console.log("MjpkiErrorCode: " + code);
    let fixedCode = -999;
    try {
      if (!isNaN(parseInt(code))) {
          fixedCode = parseInt(code);
        }
    } catch(error) {
        console.error("error=" + error);
    }
    console.log("MjpkiErrorCode(fixed): " + fixedCode);
    return fixedCode;
}

//htmlはこのオブジェクトを呼ぶ
module.exports = MJPKIPlugin;

});
